#include <string>
#include <iostream>

#include "ListeT.h"
#include "ListenContainerT.h"

using namespace std;

bool istTrennzeichen(char zeichen, string trennzeichen)
{
    for(int i=0;i<trennzeichen.size();i++)
    {
        if(zeichen == trennzeichen.at(i))
            return true;
    }
    return false;
}


void zerlegeText(ListenContainerT<string>* mLC,string text,string trennzeichen)
{
    int wortbeginn = 0;
    int wortende   = 0;

    for(int i=0;i<text.size();i++)
    {
        if(  !istTrennzeichen(text.at(i),trennzeichen) )
        {
            wortbeginn = i;
            while( i+1<text.size() && !istTrennzeichen(text.at(i+1),trennzeichen) )
                i++;

            wortende = i;
            mLC->append(text.substr(wortbeginn,wortende-wortbeginn+1));            
        }
    }
}


int main(void)
{

    string text = "Das ist ein Text.";        
    string trennzeichen = ".,;: ";
    ListenContainerT<string> mLC;

    zerlegeText(&mLC,text,trennzeichen);

    cout<<"GROESSE der Liste="<<mLC.getSize()<<endl;

    for(int i=0;i<mLC.getSize();i++)
        cout<<"Wort Nr."<<i<<":"<<mLC.get(i)<<endl;    

    ListenContainerT<double> zahlenliste;

    cout<<"Geben Sie beliebig viele Zahlen ein. Beenden Sie die Eingabe mit quit ENTER."<<endl;
    string eingabe;
    cin>>eingabe;
    while(eingabe!="quit")
    {
        zahlenliste.append(atof(eingabe.data()));
        cin>>eingabe;
    }

    cout<<"Folgende Zahlen wurden eingegeben:"<<endl;
    for(int i=0;i<zahlenliste.getSize();i++)
        cout<<zahlenliste.get(i)<<", ";
}
